workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == 'web' # bouton create pipeline de gitlab
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event' # provenant de MR
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE == 'push' # push sur main
    - if: $CI_COMMIT_TAG

variables:
  # variables utilisées pour les jobs DinD
  DOCKER_DRIVER: overlay2
  DOCKER_VERSION: 23.0.5
  DOCKER_TLS_CERTDIR: ""
  TZ: Europe/Paris
  API_IMAGE_NAME: silab-api
  FRONT_IMAGE_NAME: silab-front

default: # configuration par défaut des jobs
  retry:
    max: 1
    when:
      - "runner_system_failure"
      - "stuck_or_timeout_failure"

  tags:
    - saas-linux-medium-amd64

stages: # liste et ordonnancement des étapes
  - test
  - build
  - deploy

# piste de refacto : https://gitlab.com/gitlab-org/gitlab/-/issues/346695#note_1038152713
include:
  - local: front/.gitlab-ci.yml
  - local: api/.gitlab-ci.yml
